function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import red from '@material-ui/core/colors/red';
import FormLabel from '@material-ui/core/FormLabel';
import FormGroup from '@material-ui/core/FormGroup';
import FormControl from '@material-ui/core/FormControl';
import Button from '@material-ui/core/Button';
import Typography from '@material-ui/core/Typography';
import FileUpload from '@material-ui/icons/FileUpload';
import Dropzone from 'react-dropzone';
import FileGrid from '../../components/FileGrid';
import { removeItemArray } from '../../utils/arrayUtils';
import upload from '../../utils/upload';

var convertFilesUploadToFormDinamicoFiles = function convertFilesUploadToFormDinamicoFiles(files) {
    return files.map(function (file) {
        file.length = file.size;
        file.link = file.preview;

        return file;
    });
};

var MultipleUploadWidget = function (_Component) {
    _inherits(MultipleUploadWidget, _Component);

    function MultipleUploadWidget() {
        var _temp, _this, _ret;

        _classCallCheck(this, MultipleUploadWidget);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
            accepted: Array.isArray(_this.props.formData) ? [].concat(_this.props.formData) : [],
            loading: false,
            error: false
        }, _this.handleUploadFiles = function (accepted, rejected) {
            var onChange = _this.props.onChange;

            var config = _this.getUploadConfig();
            var originalAcceptedFiles = [].concat(_this.state.accepted);

            _this.setState(function () {
                return {
                    accepted: [].concat(originalAcceptedFiles, convertFilesUploadToFormDinamicoFiles(accepted)),
                    loading: true
                };
            });

            var promises = accepted.map(function (acceptedFile) {
                return upload(config, acceptedFile);
            });

            Promise.all(promises).then(function (values) {
                var allFiles = [].concat(originalAcceptedFiles, values).filter(function (elem, pos, arr) {
                    return arr.indexOf(elem) === pos;
                });

                _this.setState(function () {
                    return {
                        accepted: allFiles,
                        loading: false,
                        error: false
                    };
                });

                onChange(allFiles);
            }, function (error) {
                console.error('Erro ao fazer o upload', error);
                _this.setState({
                    error: error,
                    accepted: originalAcceptedFiles,
                    loading: false
                });
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    MultipleUploadWidget.prototype.createHandleDeleteClick = function createHandleDeleteClick() {
        var _this2 = this;

        var onChange = this.props.onChange;


        return function (file, index) {
            _this2.setState(function (state) {
                var array = removeItemArray(state.accepted, index);

                onChange(array);
                return { accepted: array };
            });
        };
    };

    MultipleUploadWidget.prototype.getUploadConfig = function getUploadConfig() {
        var uiSchema = this.props.uiSchema;


        return uiSchema['ui:options'].upload;
    };

    MultipleUploadWidget.prototype.renderFileList = function renderFileList() {
        var accepted = this.state.accepted;


        return React.createElement(
            'div',
            { style: { marginTop: '15px' } },
            React.createElement(FileGrid, {
                files: accepted,
                onDeleteClick: this.createHandleDeleteClick()
            })
        );
    };

    MultipleUploadWidget.prototype.renderError = function renderError() {
        return React.createElement(
            'p',
            { style: { margin: '15px 0 0' } },
            React.createElement(
                Typography,
                {
                    component: 'span',
                    style: { color: red['A400'] }
                },
                'Ocorreu um erro ao fazer o upload'
            )
        );
    };

    MultipleUploadWidget.prototype.renderUpload = function renderUpload() {
        var _this3 = this;

        var loading = this.state.loading;
        var schema = this.props.schema;


        return React.createElement(
            'div',
            { style: { marginTop: '10px' } },
            React.createElement(Dropzone, {
                ref: function ref(node) {
                    _this3.dropzoneRef = node;
                },
                onDrop: this.handleUploadFiles,
                style: { visibility: 'hidden' }
            }),
            React.createElement(
                Button,
                {
                    variant: 'raised',
                    color: 'default',
                    onClick: function onClick() {
                        _this3.dropzoneRef.open();
                    },
                    disabled: schema.disabled || loading
                },
                'Selecionar arquivos',
                React.createElement(FileUpload, null)
            )
        );
    };

    MultipleUploadWidget.prototype.render = function render() {
        var schema = this.props.schema;
        var label = schema.label;
        var _state = this.state,
            error = _state.error,
            accepted = _state.accepted;


        return React.createElement(
            'section',
            null,
            React.createElement(
                FormControl,
                { component: 'fieldset' },
                React.createElement(
                    FormLabel,
                    { component: 'legend' },
                    schema.title + (schema.required ? ' *' : '')
                )
            ),
            React.createElement(
                FormGroup,
                null,
                this.renderUpload(),
                error && this.renderError(),
                Boolean(accepted.length) && this.renderFileList()
            )
        );
    };

    return MultipleUploadWidget;
}(Component);

MultipleUploadWidget.defaultProps = {
    formData: []
};

export default MultipleUploadWidget;